#include <cstdio>
#include <fstream>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;

typedef long long LLong;

int h[maxN];
int beg[maxN];
int end[maxN];

int main() {
     int n,t,i;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&t);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&h[i]);
     
     for(i=0;i<n;i++) 
          for(beg[i]=i-1;beg[i]>=0&&h[beg[i]]<h[i];beg[i]=beg[beg[i]]);
     for(i=n-1;i>=0;i--) 
          for(end[i]=i+1;end[i]<n &&h[end[i]]<h[i];end[i]=end[end[i]]);

     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=end[i]-beg[i]-2;
          if(i>=t)cur-=end[i-t]-beg[i-t]-2;
          if(res<cur)res=cur;
     }

     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
