{$B-,R-,O+,H+}
const maxN = 100000;
infile     = 'ridge.dat';
outfile    = 'ridge.sol';
   digits  = ['0'..'9'];
var h        : array[0..maxN-1] of longint;
   view      : array[0..maxN-1] of longint;
   n,t,i,b,e : longint;
   res,cur   : int64;
   buf       : array[1..maxN*8+128] of char;
   bp        : longint;
begin
   assign(input,infile);reset(input);
   assign(output,outfile);rewrite(output);

   readln(n,t);
   readln(buf);
   
   bp:=1;
   for i:=0 to n-1 do begin
      while not (buf[bp] in digits) do inc(bp);
      h[i]:=0;
      while buf[bp] in digits do begin
         h[i]:=h[i]*10+ord(buf[bp])-ord('0');
         inc(bp);
      end;
   end;

   for i:=0 to n-1 do begin
      b:=i;while (b-1>=0) and (h[b-1]<h[i]) do dec(b);
      e:=i;while (e+1<n ) and (h[e+1]<h[i]) do inc(e);
      view[i]:=e-b;
   end;

   res:=-1;cur:=0;
   for i:=0 to n-1 do begin
      inc(cur,view[i]);
      if i>=t then dec(cur,view[i-t]);
      if res<cur then res:=cur;
   end;

   writeln(res);
   
   close(input);close(output);
end.