/* gcc_cpp */
/*

 '  CIRCLES.

O(n^2)

*/
#include <cstdio>

using namespace std;

const char *infile="circles.dat";
const char *outfile="circles.sol";

const int maxN=10000;

int x[maxN],y[maxN],r[maxN];

#define SQR(x) ((x)*(x))
inline bool intersect(int i,int j) {
     int d2=SQR(x[i]-x[j])+SQR(y[i]-y[j]);
     return d2<=SQR(r[i]+r[j])&&d2>=SQR(r[i]-r[j]);
}

int main() {
     int n,i,j;
     int ans1=-1,ans2=-1;
     FILE *ifs=fopen(infile,"r");
     FILE *ofs=fopen(outfile,"w");

     fscanf(ifs,"%d",&n);
     for(i=0;i<n;i++) {
	  fscanf(ifs,"%d%d%d",&x[i],&y[i],&r[i]);
	  for(j=0;j<i;j++)
	       if(intersect(i,j)) {		    
		    fprintf(ofs,"%d %d\n",i+1,j+1);
		    fclose(ifs);
		    fclose(ofs);
		    return 0;
	       }
     }
     fprintf(ofs,"0\n");
     fclose(ifs);
     fclose(ofs);
     return 0;
}
